#ifndef QUADRATURETRIANGLEDATA_HPP
#define QUADRATURETRIANGLEDATA_HPP

#include <format>
#ifdef BUILD_IA
#include "IAInterval.hpp"
#endif

/**
 * For analytical background see:
 * [1] D.A. Dunavant
 *     High Degree Efficient Symmetrical Gaussian Quadrature Rules for the Triangle
 *     International Journal for Numerical Methods in Engineering (1985)
 * [2] F.D. Witherden, P.E. Vincent
 *     On the identification of symmetric quadrature rules for finite element methods
 *
 * The coefficients for non-verified quadrature rules are taken from [1] and [2] respectively.
 * The verification files are given in test3_disc/quadrature/verifyquadrature!
 */

template<typename T = double>
struct QtriSymT_data0 {
  T weight;
};

template<typename T = double>
struct QtriSymT_data1 {
  T weight;
  T A;
  T B;
};

template<typename T = double>
struct QtriSymT_data2 {
  T weight;
  T A;
  T B;
  T C;
};

template<typename T = double>
struct QtriSymT_data {
  std::vector<QtriSymT_data0<T>> d0;
  std::vector<QtriSymT_data1<T>> d1;
  std::vector<QtriSymT_data2<T>> d2;

  int Size() { return d0.size() + 3 * d1.size() + 6 * d2.size(); }
};

template<typename T = double>
QtriSymT_data<T> GetQtriSymT_data(int exactUpTo);

template<>
QtriSymT_data<double> GetQtriSymT_data<double>(int exactUpTo) {
  switch (exactUpTo) {
  case 0:
  case 1:
    return QtriSymT_data<double>({{0.500000000000000}}, {}, {});
  case 2:
    return QtriSymT_data<double>({}, {{0.166666666666667, 0.000000000000000, 0.500000000000000}},
                                 {});
  case 3:
    return QtriSymT_data<double>({{-0.281250000000000}},
                                 {{0.260416666666667, 0.600000000000000, 0.200000000000000}}, {});
  case 4:
    return QtriSymT_data<double>({},
                                 {{0.111690794839006, 0.108103018168070, 0.445948490915965},
                                  {0.054975871827661, 0.816847572980459, 0.091576213509771}},
                                 {});
  case 5:
    return QtriSymT_data<double>({{0.112500000000000}},
                                 {{0.062969590272414, 0.797426985353087, 0.101286507323456},
                                  {0.066197076394253, 0.059715871789770, 0.470142064105115}},
                                 {});
  case 6:
    return QtriSymT_data<double>({},
                                 {{0.025422453185103, 0.873821971016996, 0.063089014491502},
                                  {0.058393137863190, 0.501426509658179, 0.249286745170910}},
                                 {{0.041425537809187, 0.053145049844817, 0.310352451033784,
                                   0.636502499121399}});
  case 7:
    return QtriSymT_data<double>({{-0.074785022233841}},
                                 {{0.087807628716604, 0.479308067841920, 0.260345966079040},
                                  {0.026673617804419, 0.869739794195568, 0.065130102902216}},
                                 {{0.038556880445129, 0.048690315425316, 0.312865496004874,
                                   0.638444188569810}});
  case 8:
    return QtriSymT_data<double>({{0.072157803838894}},
                                 {{0.047545817133642, 0.081414823414554, 0.459292588292723},
                                  {0.051608685267359, 0.658861384496480, 0.170569307751760},
                                  {0.016229248811599, 0.898905543365938, 0.050547228317031}},
                                 {{0.013615157087217, 0.008394777409958, 0.263112829634638,
                                   0.728492392955404}});
  case 9:
    return QtriSymT_data<double>({{0.048567898141399}},
                                 {{0.038913770502387, 0.125820817014127, 0.437089591492937},
                                  {0.039823869463605, 0.623592928761935, 0.188203535619033},
                                  {0.015667350113570, 0.020634961602525, 0.489682519198738},
                                  {0.012788837829349, 0.910540973211095, 0.044729513394453}},
                                 {{0.021641769688645, 0.036838412054736, 0.221962989160766,
                                   0.741198598784498}});
  case 10:
    return QtriSymT_data<double>({{0.045408995191377}},
                                 {{0.018362978878234, 0.028844733232685, 0.485577633383657},
                                  {0.022660529717764, 0.781036849029926, 0.109481575485037}},
                                 {{0.036378958422710, 0.307939838764121, 0.141707219414880,
                                   0.550352941820999},
                                  {0.014163621265529, 0.025003534762686, 0.246672560639903,
                                   0.728323904597411},
                                  {0.004710833481867, 0.009540815400299, 0.066803251012200,
                                   0.923655933587500}});
  case 11:
    return QtriSymT_data<double>({{0.042880589866112}},
                                 {{0.005215935256447, 0.943029164771256, 0.028485417614372},
                                  {0.035257842055858, 0.579560086593643, 0.210219956703178},
                                  {0.019315379618510, 0.794729034575507, 0.102635482712246},
                                  {0.008303136527293, 0.008216198068218, 0.495891900965891},
                                  {0.033658077039734, 0.123068146471296, 0.438465926764352}},
                                 {{0.005145144786477, 0.149324788652082, 0.007325427686064,
                                   0.843349783661853},
                                  {0.020166238320250, 0.046010500165430, 0.289581125637706,
                                   0.664408374196864}});
  case 12:
    return QtriSymT_data<double>({},
                                 {{0.012133419040726, 0.023592498108917, 0.488203750945542},
                                  {0.014243026034439, 0.781484344681291, 0.109257827659354},
                                  {0.031270606597951, 0.457074985970148, 0.271462507014926},
                                  {0.003965821254987, 0.950707273127329, 0.024646363436336},
                                  {0.024959167464030, 0.119776702682814, 0.440111648658593}},
                                 {{0.010891792519304, 0.291655679738341, 0.023034156355267,
                                   0.685310163906392},
                                  {0.021613681829707, 0.116296019677927, 0.255454228638517,
                                   0.628249751683556},
                                  {0.007541838788256, 0.851337792510240, 0.021382490256171,
                                   0.127279717233589}});
  case 13:
    return QtriSymT_data<
        double>({{0.033980018293416}},
                {{0.011997200964447, 0.021846107094921, 0.489076946452539},
                 {0.029139242559600, 0.557255427416334, 0.221372286291833},
                 {0.027800983765227, 0.146117171480399, 0.426941414259800},
                 {0.003026168551770, 0.956980637782314, 0.021509681108843}},
                {{0.012089519905797, 0.087895483032197, 0.163597401067850, 0.748507115899952},
                 {0.007482700552583, 0.110922042803463, 0.024370186901094, 0.864707770295443},
                 {0.017320638070424, 0.308441760892118, 0.068012243554207, 0.623545995553676},
                 {0.004795340501772, 0.005126389102382, 0.272515817773430, 0.722357793124188}});
  case 14:
    return QtriSymT_data<
        double>({},
                {{0.021081294368497, 0.645588935174913, 0.177205532412543},
                 {0.016394176772063, 0.164710561319092, 0.417644719340454},
                 {0.007216849834888, 0.876400233818255, 0.061799883090873},
                 {0.010941790684714, 0.022072179275643, 0.488963910362179},
                 {0.025887052253646, 0.453044943382323, 0.273477528308839},
                 {0.002461701801200, 0.961218077502598, 0.019390961248701}},
                {{0.007218154056767, 0.298372882136258, 0.014646950055654, 0.686980167808088},
                 {0.012332876606282, 0.057124757403648, 0.172266687821356, 0.770608554774996},
                 {0.019285755393530, 0.336861459796345, 0.092916249356972, 0.570222290846683},
                 {0.002505114419250, 0.001268330932872, 0.118974497696957, 0.879757171370171}});
  case 15:
    return QtriSymT_data<
        double>({{0.022167693691092}},
                {{0.021356890785730, 0.189275571732049, 0.405362214133975},
                 {0.008222368781313, 0.859652894200028, 0.070173552899986},
                 {0.008698074000382, 0.051658637123960, 0.474170681438020},
                 {0.023391680864355, 0.547242573159301, 0.226378713420350},
                 {0.004786923091230, 0.010006086461748, 0.494996956769126},
                 {0.001480387318953, 0.968376547498023, 0.015811726250989}},
                {{0.007801286415288, 0.018376112385681, 0.314648242812451, 0.666975644801868},
                 {0.002014926686009, 0.009139237037308, 0.070948605236456, 0.919912157726236},
                 {0.014360293462601, 0.190535589476394, 0.094242053592155, 0.715222356931451},
                 {0.005836310590788, 0.168068645222414, 0.018638713728166, 0.813292641049419},
                 {0.015657738142485, 0.338950611475277, 0.095796723647609, 0.565252664877114}});
  case 16:
    return QtriSymT_data<
        double>({{0.022632283036909}},
                {{0.020546461571849, 0.508019859065717, 0.245990070467142},
                 {0.020355916656213, 0.168830206229159, 0.415584896885420},
                 {0.007390817345112, 0.829288866826599, 0.085355566586700},
                 {0.014709204849494, 0.676162711617458, 0.161918644191271},
                 {0.012987166649139, 0.049438544908116, 0.475280727545942},
                 {0.002209273156075, 0.000000000000000, 0.500000000000000}},
                {{0.009469136232208, 0.054755174914703, 0.191074763640529, 0.754170061444768},
                 {0.000827233357418, 0.023203427768814, 0.008552204200228, 0.968244368030959},
                 {0.007504300892143, 0.018931778280406, 0.331764523474148, 0.649303698245446},
                 {0.003973796966696, 0.019030129743697, 0.080696166985873, 0.900273703270430},
                 {0.015991805039685, 0.102606190239398, 0.308244969196354, 0.589148840564248},
                 {0.002695593558424, 0.005936350016822, 0.187441782483782, 0.806621867499396}});
  case 17:
    return QtriSymT_data<
        double>({},
                {{0.013655463264051, 0.165793111276802, 0.417103444361599},
                 {0.001386943788819, 0.970489016678492, 0.014755491660754},
                 {0.012509725475249, 0.068804256762219, 0.465597871618890},
                 {0.013156315294009, 0.639283767467259, 0.180358116266371},
                 {0.006229500401153, 0.866691873040806, 0.066654063479597},
                 {0.018858118576398, 0.428586995126827, 0.285706502436587}},
                {{0.003989150102965, 0.016017642362119, 0.159192287472793, 0.824790070165088},
                 {0.011243886273346, 0.306281591746187, 0.067349377867361, 0.626369030386452},
                 {0.005199219977920, 0.013229672760087, 0.415475459295229, 0.571294867944684},
                 {0.010278949160227, 0.078042340568282, 0.168722513495259, 0.753235145936458},
                 {0.004346107250501, 0.013135870834003, 0.271791870055355, 0.715072259110642},
                 {0.002292174200868, 0.011575175903181, 0.072505470799002, 0.915919353297817},
                 {0.013085812967668, 0.157505477926870, 0.299218942476970, 0.543275579596160}});
  case 18:
    return QtriSymT_data<
        double>({{0.018177867650713}},
                {{0.016652235016695, 0.200088743864848, 0.399955628067576},
                 {0.006023323817000, 0.024839396850261, 0.487580301574870},
                 {0.009474585753389, 0.076380987187102, 0.461809506406449},
                 {0.018237544704472, 0.515470594971456, 0.242264702514272},
                 {0.003564663009859, 0.922339487822629, 0.038830256088686},
                 {0.008279579976002, 0.816104515756714, 0.091947742121643}},
                {{0.006879808117471, 0.045804915859861, 0.183822707925464, 0.770372376214675},
                 {0.011890955450076, 0.206349257433838, 0.122696757371928, 0.670953985194235},
                 {0.002265267251129, 0.003897611033473, 0.395683434332270, 0.600418954634257},
                 {0.003420055059804, 0.013462016741445, 0.108195793791033, 0.878342189467522},
                 {0.008873744551010, 0.040260283469908, 0.319751624525377, 0.639988092004715},
                 {0.002505330437290, 0.005298335186610, 0.235772184958192, 0.758929479855198},
                 {0.000611474063481, 0.000548360042042, 0.027090910995162, 0.972360728962796},
                 {0.012741087655912, 0.120587695163925, 0.333493529449881, 0.545918775386195}});
  case 19:
    return QtriSymT_data<
        double>({{0.016453165694459}},
                {{0.005165365945636, 0.020780025853986, 0.489609987073007},
                 {0.011193623631508, 0.090926214604214, 0.454536892697893},
                 {0.015133062934734, 0.197166638701137, 0.401416680649431},
                 {0.015245483901099, 0.488896691193805, 0.255551654403097},
                 {0.012079606370820, 0.645844115695741, 0.177077942152129},
                 {0.008025401793400, 0.779877893544095, 0.110061053227952},
                 {0.004042290130892, 0.888942751496322, 0.055528624251839},
                 {0.001039681013742, 0.974756272445543, 0.012621863777229}},
                {{0.001942438452491, 0.003611417848412, 0.395754787356939, 0.600633794794649},
                 {0.012787080306011, 0.134466754530779, 0.307929983880436, 0.557603261588784},
                 {0.004440451786669, 0.014446025776115, 0.264566948406519, 0.720987025817366},
                 {0.008062273380866, 0.046933578838178, 0.358539352205952, 0.594527068955870},
                 {0.001245970908746, 0.002861120350568, 0.157807405968595, 0.839331473680837},
                 {0.009121420059475, 0.223861424097917, 0.075050596975911, 0.701087978926173},
                 {0.005129281868099, 0.034647074816762, 0.142421601113382, 0.822931324069856},
                 {0.001899964427651, 0.010161119296278, 0.065494628082938, 0.924344252620784}});
  case 20:
    return QtriSymT_data<
        double>({{0.013910110701453}},
                {{0.014083201307520, 0.490841464653322, 0.254579267673339},
                 {0.000798840791067, 0.978047717943205, 0.010976141028398},
                 {0.007830230776075, 0.781232806576571, 0.109383596711715},
                 {0.009173462974253, 0.627410004510918, 0.186294997744541},
                 {0.009452399933232, 0.108897886088150, 0.445551056955925},
                 {0.002161275410666, 0.925378238802231, 0.037310880598885},
                 {0.013788050629070, 0.213149304365800, 0.393425347817100},
                 {0.007101825303408, 0.047508776919002, 0.476245611540499}},
                {{0.002202897418558, 0.007570780504697, 0.159133707657067, 0.833295511838236},
                 {0.005986398578955, 0.046560364907664, 0.198518132228788, 0.754921502863547},
                 {0.001129869602126, 0.064090585608434, 0.004854937607624, 0.931054476783942},
                 {0.008667225567219, 0.054987479142987, 0.333134817309587, 0.611877703547426},
                 {0.004145711527614, 0.099952296288139, 0.038363684775375, 0.861684018936487},
                 {0.007722607822099, 0.106227204720270, 0.215607057390094, 0.678165737889636},
                 {0.003695681500255, 0.420023758816224, 0.009831548292803, 0.570144692890973},
                 {0.011691745731828, 0.317860123835772, 0.139808071991800, 0.542331804172428},
                 {0.003578200238458, 0.010737212856011, 0.280581411423665, 0.708681375720324}});
  default:
    Exit(std::format("Quadrature exact up to degree {} not implemented for triangles!", exactUpTo));
  }
}

#ifdef BUILD_IA

template<>
QtriSymT_data<IAInterval> GetQtriSymT_data<IAInterval>(int exactUpTo) {
  switch (exactUpTo) {
  case 0:
  case 1:
    return QtriSymT_data<IAInterval>({{IAInterval(0.500000000000000, 0.500000000000000)}}, {}, {});
  case 2:
    return QtriSymT_data<IAInterval>({},
                                     {{IAInterval(0.166666666666666, 0.166666666666667),
                                       IAInterval(-1.387778973671138E-024, 1.387778829868369E-024),
                                       IAInterval(0.499999999999999, 0.500000000000001)}},
                                     {});
  case 3:
    return QtriSymT_data<IAInterval>({{IAInterval(-0.281250000000001, -0.281249999999999)}},
                                     {{IAInterval(0.260416666666666, 0.260416666666667),
                                       IAInterval(0.599999999999999, 0.600000000000001),
                                       IAInterval(0.199999999999999, 0.200000000000001)}},
                                     {});
  case 4:
    return QtriSymT_data<IAInterval>({},
                                     {{IAInterval(0.111690794839005, 0.111690794839006),
                                       IAInterval(0.108103018168070, 0.108103018168071),
                                       IAInterval(0.445948490915964, 0.445948490915965)},
                                      {IAInterval(0.054975871827660, 0.054975871827661),
                                       IAInterval(0.816847572980458, 0.816847572980459),
                                       IAInterval(0.091576213509770, 0.091576213509771)}},
                                     {});
  case 5:
    return QtriSymT_data<IAInterval>({{IAInterval(0.112499999999999, 0.112500000000001)}},
                                     {{IAInterval(0.062969590272413, 0.062969590272414),
                                       IAInterval(0.797426985353087, 0.797426985353088),
                                       IAInterval(0.101286507323456, 0.101286507323457)},
                                      {IAInterval(0.066197076394253, 0.066197076394254),
                                       IAInterval(0.059715871789769, 0.059715871789770),
                                       IAInterval(0.470142064105115, 0.470142064105116)}},
                                     {});
  case 6:
    return QtriSymT_data<IAInterval>({},
                                     {{IAInterval(0.025422453185103, 0.025422453185104),
                                       IAInterval(0.873821971016995, 0.873821971016996),
                                       IAInterval(0.063089014491502, 0.063089014491503)},
                                      {IAInterval(0.058393137863189, 0.058393137863190),
                                       IAInterval(0.501426509658179, 0.501426509658180),
                                       IAInterval(0.249286745170910, 0.249286745170911)}},
                                     {{IAInterval(0.041425537809186, 0.041425537809187),
                                       IAInterval(0.053145049844816, 0.053145049844817),
                                       IAInterval(0.310352451033784, 0.310352451033785),
                                       IAInterval(0.636502499121398, 0.636502499121399)}});
  case 7:
    return QtriSymT_data<IAInterval>({{IAInterval(-0.074785022233841, -0.074785022233840)}},
                                     {{IAInterval(0.087807628716603, 0.087807628716604),
                                       IAInterval(0.479308067841920, 0.479308067841921),
                                       IAInterval(0.260345966079039, 0.260345966079040)},
                                      {IAInterval(0.026673617804419, 0.026673617804420),
                                       IAInterval(0.869739794195568, 0.869739794195569),
                                       IAInterval(0.065130102902215, 0.065130102902216)}},
                                     {{IAInterval(0.038556880445128, 0.038556880445129),
                                       IAInterval(0.048690315425316, 0.048690315425317),
                                       IAInterval(0.312865496004873, 0.312865496004874),
                                       IAInterval(0.638444188569809, 0.638444188569810)}});
  case 8:
    return QtriSymT_data<IAInterval>({{IAInterval(0.072157803838893, 0.072157803838894)}},
                                     {{IAInterval(0.047545817133642, 0.047545817133643),
                                       IAInterval(0.081414823414553, 0.081414823414554),
                                       IAInterval(0.459292588292723, 0.459292588292724)},
                                      {IAInterval(0.051608685267359, 0.051608685267360),
                                       IAInterval(0.658861384496479, 0.658861384496480),
                                       IAInterval(0.170569307751760, 0.170569307751761)},
                                      {IAInterval(0.016229248811599, 0.016229248811600),
                                       IAInterval(0.898905543365937, 0.898905543365939),
                                       IAInterval(0.050547228317030, 0.050547228317031)}},
                                     {{IAInterval(0.013615157087217, 0.013615157087218),
                                       IAInterval(0.008394777409957, 0.008394777409958),
                                       IAInterval(0.263112829634638, 0.263112829634639),
                                       IAInterval(0.728492392955404, 0.728492392955405)}});
  case 9:
    return QtriSymT_data<IAInterval>({{IAInterval(0.048567898141399, 0.048567898141400)}},
                                     {{IAInterval(0.038913770502387, 0.038913770502388),
                                       IAInterval(0.125820817014126, 0.125820817014127),
                                       IAInterval(0.437089591492936, 0.437089591492937)},
                                      {IAInterval(0.039823869463605, 0.039823869463606),
                                       IAInterval(0.623592928761934, 0.623592928761935),
                                       IAInterval(0.188203535619032, 0.188203535619033)},
                                      {IAInterval(0.015667350113569, 0.015667350113570),
                                       IAInterval(0.020634961602524, 0.020634961602525),
                                       IAInterval(0.489682519198737, 0.489682519198738)},
                                      {IAInterval(0.012788837829349, 0.012788837829350),
                                       IAInterval(0.910540973211094, 0.910540973211095),
                                       IAInterval(0.044729513394452, 0.044729513394453)}},
                                     {{IAInterval(0.021641769688644, 0.021641769688645),
                                       IAInterval(0.036838412054736, 0.036838412054737),
                                       IAInterval(0.221962989160765, 0.221962989160766),
                                       IAInterval(0.741198598784497, 0.741198598784499)}});
  case 10:
    return QtriSymT_data<IAInterval>({{IAInterval(0.045408995191376, 0.045408995191377)}},
                                     {{IAInterval(0.018362978878233, 0.018362978878234),
                                       IAInterval(0.028844733232685, 0.028844733232686),
                                       IAInterval(0.485577633383657, 0.485577633383658)},
                                      {IAInterval(0.022660529717763, 0.022660529717764),
                                       IAInterval(0.781036849029925, 0.781036849029926),
                                       IAInterval(0.109481575485037, 0.109481575485038)}},
                                     {{IAInterval(0.036378958422710, 0.036378958422711),
                                       IAInterval(0.307939838764120, 0.307939838764121),
                                       IAInterval(0.141707219414879, 0.141707219414880),
                                       IAInterval(0.550352941820999, 0.550352941821000)},
                                      {IAInterval(0.014163621265528, 0.014163621265529),
                                       IAInterval(0.025003534762686, 0.025003534762687),
                                       IAInterval(0.246672560639902, 0.246672560639903),
                                       IAInterval(0.728323904597410, 0.728323904597411)},
                                      {IAInterval(0.004710833481866, 0.004710833481867),
                                       IAInterval(0.009540815400299, 0.009540815400300),
                                       IAInterval(0.066803251012200, 0.066803251012201),
                                       IAInterval(0.923655933587500, 0.923655933587501)}});
  case 11:
    return QtriSymT_data<IAInterval>({{IAInterval(0.042880589866111, 0.042880589866113)}},
                                     {{IAInterval(0.005215935256447, 0.005215935256448),
                                       IAInterval(0.943029164771255, 0.943029164771256),
                                       IAInterval(0.028485417614372, 0.028485417614373)},
                                      {IAInterval(0.035257842055858, 0.035257842055859),
                                       IAInterval(0.579560086593642, 0.579560086593643),
                                       IAInterval(0.210219956703178, 0.210219956703179)},
                                      {IAInterval(0.019315379618509, 0.019315379618510),
                                       IAInterval(0.794729034575505, 0.794729034575506),
                                       IAInterval(0.102635482712247, 0.102635482712248)},
                                      {IAInterval(0.008303136527292, 0.008303136527293),
                                       IAInterval(0.008216198068217, 0.008216198068218),
                                       IAInterval(0.495891900965891, 0.495891900965892)},
                                      {IAInterval(0.033658077039734, 0.033658077039735),
                                       IAInterval(0.123068146471295, 0.123068146471296),
                                       IAInterval(0.438465926764352, 0.438465926764353)}},
                                     {{IAInterval(0.005145144786476, 0.005145144786477),
                                       IAInterval(0.149324788652083, 0.149324788652084),
                                       IAInterval(0.007325427686064, 0.007325427686065),
                                       IAInterval(0.843349783661851, 0.843349783661852)},
                                      {IAInterval(0.020166238320250, 0.020166238320251),
                                       IAInterval(0.046010500165430, 0.046010500165431),
                                       IAInterval(0.289581125637706, 0.289581125637708),
                                       IAInterval(0.664408374196862, 0.664408374196863)}});
  case 12:
    return QtriSymT_data<IAInterval>({},
                                     {{IAInterval(0.012133419040726, 0.012133419040727),
                                       IAInterval(0.023592498108916, 0.023592498108917),
                                       IAInterval(0.488203750945541, 0.488203750945542)},
                                      {IAInterval(0.014243026034438, 0.014243026034439),
                                       IAInterval(0.781484344681291, 0.781484344681292),
                                       IAInterval(0.109257827659354, 0.109257827659355)},
                                      {IAInterval(0.031270606597951, 0.031270606597952),
                                       IAInterval(0.457074985970147, 0.457074985970148),
                                       IAInterval(0.271462507014926, 0.271462507014927)},
                                      {IAInterval(0.003965821254986, 0.003965821254987),
                                       IAInterval(0.950707273127328, 0.950707273127329),
                                       IAInterval(0.024646363436335, 0.024646363436336)},
                                      {IAInterval(0.024959167464030, 0.024959167464031),
                                       IAInterval(0.119776702682813, 0.119776702682814),
                                       IAInterval(0.440111648658593, 0.440111648658594)}},
                                     {{IAInterval(0.010891792519303, 0.010891792519304),
                                       IAInterval(0.291655679738340, 0.291655679738342),
                                       IAInterval(0.023034156355267, 0.023034156355268),
                                       IAInterval(0.685310163906391, 0.685310163906392)},
                                      {IAInterval(0.021613681829707, 0.021613681829708),
                                       IAInterval(0.116296019677926, 0.116296019677927),
                                       IAInterval(0.255454228638517, 0.255454228638518),
                                       IAInterval(0.628249751683556, 0.628249751683557)},
                                      {IAInterval(0.007541838788255, 0.007541838788256),
                                       IAInterval(0.851337792510239, 0.851337792510241),
                                       IAInterval(0.021382490256170, 0.021382490256171),
                                       IAInterval(0.127279717233589, 0.127279717233590)}});
  case 13:
    return QtriSymT_data<IAInterval>({{IAInterval(0.033980018293415, 0.033980018293416)}},
                                     {{IAInterval(0.011997200964447, 0.011997200964448),
                                       IAInterval(0.021846107094921, 0.021846107094922),
                                       IAInterval(0.489076946452539, 0.489076946452540)},
                                      {IAInterval(0.029139242559599, 0.029139242559600),
                                       IAInterval(0.557255427416334, 0.557255427416335),
                                       IAInterval(0.221372286291832, 0.221372286291833)},
                                      {IAInterval(0.027800983765226, 0.027800983765227),
                                       IAInterval(0.146117171480399, 0.146117171480400),
                                       IAInterval(0.426941414259800, 0.426941414259801)},
                                      {IAInterval(0.003026168551769, 0.003026168551770),
                                       IAInterval(0.956980637782313, 0.956980637782314),
                                       IAInterval(0.021509681108843, 0.021509681108844)}},
                                     {{IAInterval(0.012089519905796, 0.012089519905797),
                                       IAInterval(0.087895483032197, 0.087895483032198),
                                       IAInterval(0.163597401067850, 0.163597401067851),
                                       IAInterval(0.748507115899952, 0.748507115899953)},
                                      {IAInterval(0.007482700552582, 0.007482700552583),
                                       IAInterval(0.110922042803463, 0.110922042803464),
                                       IAInterval(0.024370186901093, 0.024370186901094),
                                       IAInterval(0.864707770295442, 0.864707770295443)},
                                      {IAInterval(0.017320638070424, 0.017320638070425),
                                       IAInterval(0.308441760892117, 0.308441760892118),
                                       IAInterval(0.068012243554206, 0.068012243554207),
                                       IAInterval(0.623545995553675, 0.623545995553676)},
                                      {IAInterval(0.004795340501771, 0.004795340501772),
                                       IAInterval(0.005126389102382, 0.005126389102383),
                                       IAInterval(0.272515817773429, 0.272515817773430),
                                       IAInterval(0.722357793124187, 0.722357793124189)}});
  case 14:
    return QtriSymT_data<IAInterval>({},
                                     {{IAInterval(0.021081294368496, 0.021081294368497),
                                       IAInterval(0.645588935174913, 0.645588935174914),
                                       IAInterval(0.177205532412543, 0.177205532412544)},
                                      {IAInterval(0.016394176772062, 0.016394176772063),
                                       IAInterval(0.164710561319092, 0.164710561319093),
                                       IAInterval(0.417644719340453, 0.417644719340454)},
                                      {IAInterval(0.007216849834888, 0.007216849834889),
                                       IAInterval(0.876400233818254, 0.876400233818255),
                                       IAInterval(0.061799883090872, 0.061799883090873)},
                                      {IAInterval(0.010941790684714, 0.010941790684715),
                                       IAInterval(0.022072179275642, 0.022072179275643),
                                       IAInterval(0.488963910362178, 0.488963910362179)},
                                      {IAInterval(0.025887052253645, 0.025887052253646),
                                       IAInterval(0.453044943382322, 0.453044943382323),
                                       IAInterval(0.273477528308838, 0.273477528308839)},
                                      {IAInterval(0.002461701801200, 0.002461701801201),
                                       IAInterval(0.961218077502597, 0.961218077502598),
                                       IAInterval(0.019390961248701, 0.019390961248702)}},
                                     {{IAInterval(0.007218154056766, 0.007218154056767),
                                       IAInterval(0.298372882136257, 0.298372882136258),
                                       IAInterval(0.014646950055654, 0.014646950055655),
                                       IAInterval(0.686980167808087, 0.686980167808088)},
                                      {IAInterval(0.012332876606281, 0.012332876606282),
                                       IAInterval(0.057124757403647, 0.057124757403648),
                                       IAInterval(0.172266687821355, 0.172266687821356),
                                       IAInterval(0.770608554774996, 0.770608554774997)},
                                      {IAInterval(0.019285755393530, 0.019285755393531),
                                       IAInterval(0.336861459796344, 0.336861459796346),
                                       IAInterval(0.092916249356971, 0.092916249356972),
                                       IAInterval(0.570222290846683, 0.570222290846684)},
                                      {IAInterval(0.002505114419250, 0.002505114419251),
                                       IAInterval(0.001268330932872, 0.001268330932873),
                                       IAInterval(0.118974497696956, 0.118974497696957),
                                       IAInterval(0.879757171370171, 0.879757171370172)}});
  case 15:
    return QtriSymT_data<IAInterval>({{IAInterval(0.022167693691091, 0.022167693691093)}},
                                     {{IAInterval(0.021356890785730, 0.021356890785731),
                                       IAInterval(0.189275571732049, 0.189275571732050),
                                       IAInterval(0.405362214133975, 0.405362214133976)},
                                      {IAInterval(0.008222368781312, 0.008222368781313),
                                       IAInterval(0.859652894200029, 0.859652894200030),
                                       IAInterval(0.070173552899985, 0.070173552899986)},
                                      {IAInterval(0.008698074000381, 0.008698074000382),
                                       IAInterval(0.051658637123962, 0.051658637123963),
                                       IAInterval(0.474170681438018, 0.474170681438019)},
                                      {IAInterval(0.023391680864354, 0.023391680864355),
                                       IAInterval(0.547242573159301, 0.547242573159302),
                                       IAInterval(0.226378713420349, 0.226378713420350)},
                                      {IAInterval(0.004786923091230, 0.004786923091231),
                                       IAInterval(0.010006086461748, 0.010006086461749),
                                       IAInterval(0.494996956769125, 0.494996956769126)},
                                      {IAInterval(0.001480387318952, 0.001480387318953),
                                       IAInterval(0.968376547498022, 0.968376547498023),
                                       IAInterval(0.015811726250988, 0.015811726250989)}},
                                     {{IAInterval(0.007801286415288, 0.007801286415289),
                                       IAInterval(0.018376112385681, 0.018376112385682),
                                       IAInterval(0.314648242812450, 0.314648242812451),
                                       IAInterval(0.666975644801868, 0.666975644801869)},
                                      {IAInterval(0.002014926686008, 0.002014926686009),
                                       IAInterval(0.009139237037308, 0.009139237037309),
                                       IAInterval(0.070948605236454, 0.070948605236455),
                                       IAInterval(0.919912157726237, 0.919912157726238)},
                                      {IAInterval(0.014360293462600, 0.014360293462601),
                                       IAInterval(0.190535589476393, 0.190535589476394),
                                       IAInterval(0.094242053592155, 0.094242053592156),
                                       IAInterval(0.715222356931451, 0.715222356931452)},
                                      {IAInterval(0.005836310590787, 0.005836310590788),
                                       IAInterval(0.168068645222413, 0.168068645222414),
                                       IAInterval(0.018638713728166, 0.018638713728167),
                                       IAInterval(0.813292641049420, 0.813292641049421)},
                                      {IAInterval(0.015657738142484, 0.015657738142485),
                                       IAInterval(0.338950611475275, 0.338950611475276),
                                       IAInterval(0.095796723647608, 0.095796723647609),
                                       IAInterval(0.565252664877115, 0.565252664877116)}});
  case 16:
    return QtriSymT_data<IAInterval>({{IAInterval(0.022632283036909, 0.022632283036910)}},
                                     {{IAInterval(0.020546461571849, 0.020546461571850),
                                       IAInterval(0.508019859065716, 0.508019859065717),
                                       IAInterval(0.245990070467141, 0.245990070467142)},
                                      {IAInterval(0.020355916656212, 0.020355916656213),
                                       IAInterval(0.168830206229158, 0.168830206229159),
                                       IAInterval(0.415584896885420, 0.415584896885421)},
                                      {IAInterval(0.007390817345112, 0.007390817345113),
                                       IAInterval(0.829288866826599, 0.829288866826600),
                                       IAInterval(0.085355566586700, 0.085355566586701)},
                                      {IAInterval(0.014709204849494, 0.014709204849495),
                                       IAInterval(0.676162711617457, 0.676162711617458),
                                       IAInterval(0.161918644191271, 0.161918644191272)},
                                      {IAInterval(0.012987166649138, 0.012987166649139),
                                       IAInterval(0.049438544908115, 0.049438544908116),
                                       IAInterval(0.475280727545942, 0.475280727545943)},
                                      {IAInterval(0.002209273156075, 0.002209273156076),
                                       IAInterval(-0.000000000000000, 0.000000000000000),
                                       IAInterval(0.500000000000000, 0.500000000000000)}},
                                     {{IAInterval(0.009469136232207, 0.009469136232208),
                                       IAInterval(0.054755174914703, 0.054755174914704),
                                       IAInterval(0.191074763640529, 0.191074763640530),
                                       IAInterval(0.754170061444767, 0.754170061444768)},
                                      {IAInterval(0.000827233357417, 0.000827233357418),
                                       IAInterval(0.023203427768813, 0.023203427768814),
                                       IAInterval(0.008552204200227, 0.008552204200228),
                                       IAInterval(0.968244368030958, 0.968244368030959)},
                                      {IAInterval(0.007504300892142, 0.007504300892143),
                                       IAInterval(0.018931778280405, 0.018931778280406),
                                       IAInterval(0.331764523474147, 0.331764523474148),
                                       IAInterval(0.649303698245446, 0.649303698245447)},
                                      {IAInterval(0.003973796966696, 0.003973796966697),
                                       IAInterval(0.019030129743697, 0.019030129743698),
                                       IAInterval(0.080696166985872, 0.080696166985873),
                                       IAInterval(0.900273703270429, 0.900273703270430)},
                                      {IAInterval(0.015991805039685, 0.015991805039686),
                                       IAInterval(0.102606190239398, 0.102606190239399),
                                       IAInterval(0.308244969196353, 0.308244969196355),
                                       IAInterval(0.589148840564247, 0.589148840564248)},
                                      {IAInterval(0.002695593558424, 0.002695593558425),
                                       IAInterval(0.005936350016822, 0.005936350016823),
                                       IAInterval(0.187441782483782, 0.187441782483783),
                                       IAInterval(0.806621867499395, 0.806621867499396)}});
  case 17:
    return QtriSymT_data<IAInterval>({},
                                     {{IAInterval(0.013655463264051, 0.013655463264052),
                                       IAInterval(0.165793111276801, 0.165793111276802),
                                       IAInterval(0.417103444361599, 0.417103444361600)},
                                      {IAInterval(0.001386943788818, 0.001386943788819),
                                       IAInterval(0.970489016678492, 0.970489016678493),
                                       IAInterval(0.014755491660753, 0.014755491660754)},
                                      {IAInterval(0.012509725475248, 0.012509725475249),
                                       IAInterval(0.068804256762219, 0.068804256762220),
                                       IAInterval(0.465597871618890, 0.465597871618891)},
                                      {IAInterval(0.013156315294008, 0.013156315294009),
                                       IAInterval(0.639283767467258, 0.639283767467259),
                                       IAInterval(0.180358116266370, 0.180358116266371)},
                                      {IAInterval(0.006229500401152, 0.006229500401153),
                                       IAInterval(0.866691873040806, 0.866691873040807),
                                       IAInterval(0.066654063479596, 0.066654063479597)},
                                      {IAInterval(0.018858118576397, 0.018858118576398),
                                       IAInterval(0.428586995126826, 0.428586995126827),
                                       IAInterval(0.285706502436586, 0.285706502436587)}},
                                     {{IAInterval(0.003989150102964, 0.003989150102965),
                                       IAInterval(0.016017642362119, 0.016017642362120),
                                       IAInterval(0.159192287472792, 0.159192287472793),
                                       IAInterval(0.824790070165087, 0.824790070165089)},
                                      {IAInterval(0.011243886273345, 0.011243886273346),
                                       IAInterval(0.306281591746186, 0.306281591746187),
                                       IAInterval(0.067349377867361, 0.067349377867362),
                                       IAInterval(0.626369030386452, 0.626369030386453)},
                                      {IAInterval(0.005199219977919, 0.005199219977920),
                                       IAInterval(0.013229672760086, 0.013229672760087),
                                       IAInterval(0.415475459295229, 0.415475459295230),
                                       IAInterval(0.571294867944683, 0.571294867944685)},
                                      {IAInterval(0.010278949160227, 0.010278949160228),
                                       IAInterval(0.078042340568282, 0.078042340568283),
                                       IAInterval(0.168722513495259, 0.168722513495260),
                                       IAInterval(0.753235145936458, 0.753235145936459)},
                                      {IAInterval(0.004346107250500, 0.004346107250501),
                                       IAInterval(0.013135870834002, 0.013135870834003),
                                       IAInterval(0.271791870055354, 0.271791870055355),
                                       IAInterval(0.715072259110642, 0.715072259110643)},
                                      {IAInterval(0.002292174200867, 0.002292174200868),
                                       IAInterval(0.011575175903180, 0.011575175903181),
                                       IAInterval(0.072505470799002, 0.072505470799003),
                                       IAInterval(0.915919353297816, 0.915919353297818)},
                                      {IAInterval(0.013085812967668, 0.013085812967669),
                                       IAInterval(0.157505477926869, 0.157505477926870),
                                       IAInterval(0.299218942476970, 0.299218942476971),
                                       IAInterval(0.543275579596159, 0.543275579596160)}});
  case 18:
    return QtriSymT_data<IAInterval>({{IAInterval(0.018177867650713, 0.018177867650714)}},
                                     {{IAInterval(0.016652235016695, 0.016652235016696),
                                       IAInterval(0.200088743864847, 0.200088743864848),
                                       IAInterval(0.399955628067576, 0.399955628067577)},
                                      {IAInterval(0.006023323816999, 0.006023323817000),
                                       IAInterval(0.024839396850260, 0.024839396850261),
                                       IAInterval(0.487580301574869, 0.487580301574870)},
                                      {IAInterval(0.009474585753389, 0.009474585753390),
                                       IAInterval(0.076380987187101, 0.076380987187102),
                                       IAInterval(0.461809506406449, 0.461809506406450)},
                                      {IAInterval(0.018237544704471, 0.018237544704472),
                                       IAInterval(0.515470594971455, 0.515470594971457),
                                       IAInterval(0.242264702514271, 0.242264702514272)},
                                      {IAInterval(0.003564663009859, 0.003564663009860),
                                       IAInterval(0.922339487822628, 0.922339487822629),
                                       IAInterval(0.038830256088685, 0.038830256088686)},
                                      {IAInterval(0.008279579976001, 0.008279579976002),
                                       IAInterval(0.816104515756713, 0.816104515756714),
                                       IAInterval(0.091947742121643, 0.091947742121644)}},
                                     {{IAInterval(0.006879808117471, 0.006879808117472),
                                       IAInterval(0.045804915859860, 0.045804915859861),
                                       IAInterval(0.183822707925463, 0.183822707925465),
                                       IAInterval(0.770372376214675, 0.770372376214676)},
                                      {IAInterval(0.011890955450076, 0.011890955450077),
                                       IAInterval(0.206349257433837, 0.206349257433838),
                                       IAInterval(0.122696757371927, 0.122696757371928),
                                       IAInterval(0.670953985194234, 0.670953985194235)},
                                      {IAInterval(0.002265267251128, 0.002265267251129),
                                       IAInterval(0.003897611033473, 0.003897611033474),
                                       IAInterval(0.395683434332269, 0.395683434332270),
                                       IAInterval(0.600418954634256, 0.600418954634257)},
                                      {IAInterval(0.003420055059803, 0.003420055059804),
                                       IAInterval(0.013462016741444, 0.013462016741445),
                                       IAInterval(0.108195793791033, 0.108195793791034),
                                       IAInterval(0.878342189467521, 0.878342189467522)},
                                      {IAInterval(0.008873744551010, 0.008873744551011),
                                       IAInterval(0.040260283469908, 0.040260283469909),
                                       IAInterval(0.319751624525377, 0.319751624525378),
                                       IAInterval(0.639988092004714, 0.639988092004715)},
                                      {IAInterval(0.002505330437289, 0.002505330437290),
                                       IAInterval(0.005298335186609, 0.005298335186610),
                                       IAInterval(0.235772184958191, 0.235772184958192),
                                       IAInterval(0.758929479855198, 0.758929479855199)},
                                      {IAInterval(0.000611474063480, 0.000611474063481),
                                       IAInterval(0.000548360042042, 0.000548360042043),
                                       IAInterval(0.027090910995162, 0.027090910995163),
                                       IAInterval(0.972360728962795, 0.972360728962796)},
                                      {IAInterval(0.012741087655912, 0.012741087655913),
                                       IAInterval(0.120587695163924, 0.120587695163925),
                                       IAInterval(0.333493529449880, 0.333493529449881),
                                       IAInterval(0.545918775386194, 0.545918775386195)}});
  case 19:
    return QtriSymT_data<IAInterval>({{IAInterval(0.016453165694458, 0.016453165694460)}},
                                     {{IAInterval(0.005165365945634, 0.005165365945638),
                                       IAInterval(0.020780025853979, 0.020780025853993),
                                       IAInterval(0.489609987073003, 0.489609987073011)},
                                      {IAInterval(0.011193623631506, 0.011193623631510),
                                       IAInterval(0.090926214604207, 0.090926214604221),
                                       IAInterval(0.454536892697889, 0.454536892697897)},
                                      {IAInterval(0.015133062934732, 0.015133062934736),
                                       IAInterval(0.197166638701130, 0.197166638701144),
                                       IAInterval(0.401416680649428, 0.401416680649435)},
                                      {IAInterval(0.015245483901097, 0.015245483901101),
                                       IAInterval(0.488896691193798, 0.488896691193812),
                                       IAInterval(0.255551654403094, 0.255551654403101)},
                                      {IAInterval(0.012079606370818, 0.012079606370822),
                                       IAInterval(0.645844115695734, 0.645844115695748),
                                       IAInterval(0.177077942152126, 0.177077942152133)},
                                      {IAInterval(0.008025401793398, 0.008025401793402),
                                       IAInterval(0.779877893544088, 0.779877893544102),
                                       IAInterval(0.110061053227949, 0.110061053227956)},
                                      {IAInterval(0.004042290130890, 0.004042290130894),
                                       IAInterval(0.888942751496315, 0.888942751496329),
                                       IAInterval(0.055528624251835, 0.055528624251843)},
                                      {IAInterval(0.001039681013740, 0.001039681013744),
                                       IAInterval(0.974756272445536, 0.974756272445550),
                                       IAInterval(0.012621863777225, 0.012621863777232)}},
                                     {{IAInterval(0.001942438452490, 0.001942438452492),
                                       IAInterval(0.003611417848403, 0.003611417848420),
                                       IAInterval(0.395754787356929, 0.395754787356948),
                                       IAInterval(0.600633794794632, 0.600633794794667)},
                                      {IAInterval(0.012787080306010, 0.012787080306012),
                                       IAInterval(0.134466754530769, 0.134466754530785),
                                       IAInterval(0.307929983880426, 0.307929983880445),
                                       IAInterval(0.557603261588770, 0.557603261588804)},
                                      {IAInterval(0.004440451786668, 0.004440451786670),
                                       IAInterval(0.014446025776105, 0.014446025776123),
                                       IAInterval(0.264566948406507, 0.264566948406530),
                                       IAInterval(0.720987025817347, 0.720987025817387)},
                                      {IAInterval(0.008062273380865, 0.008062273380867),
                                       IAInterval(0.046933578838169, 0.046933578838185),
                                       IAInterval(0.358539352205942, 0.358539352205962),
                                       IAInterval(0.594527068955854, 0.594527068955889)},
                                      {IAInterval(0.001245970908745, 0.001245970908747),
                                       IAInterval(0.002861120350557, 0.002861120350576),
                                       IAInterval(0.157807405968582, 0.157807405968607),
                                       IAInterval(0.839331473680817, 0.839331473680860)},
                                      {IAInterval(0.009121420059474, 0.009121420059476),
                                       IAInterval(0.223861424097908, 0.223861424097920),
                                       IAInterval(0.075050596975895, 0.075050596975915),
                                       IAInterval(0.701087978926165, 0.701087978926197)},
                                      {IAInterval(0.005129281868098, 0.005129281868100),
                                       IAInterval(0.034647074816752, 0.034647074816770),
                                       IAInterval(0.142421601113369, 0.142421601113394),
                                       IAInterval(0.822931324069837, 0.822931324069879)},
                                      {IAInterval(0.001899964427650, 0.001899964427652),
                                       IAInterval(0.010161119296267, 0.010161119296286),
                                       IAInterval(0.065494628082924, 0.065494628082951),
                                       IAInterval(0.924344252620763, 0.924344252620809)}});
  case 20:
    return QtriSymT_data<IAInterval>({{IAInterval(0.013910110701447, 0.013910110701459)}},
                                     {{IAInterval(0.014083201307518, 0.014083201307522),
                                       IAInterval(0.490841464653315, 0.490841464653329),
                                       IAInterval(0.254579267673335, 0.254579267673343)},
                                      {IAInterval(0.000798840791065, 0.000798840791069),
                                       IAInterval(0.978047717943198, 0.978047717943212),
                                       IAInterval(0.010976141028394, 0.010976141028401)},
                                      {IAInterval(0.007830230776073, 0.007830230776077),
                                       IAInterval(0.781232806576564, 0.781232806576578),
                                       IAInterval(0.109383596711711, 0.109383596711718)},
                                      {IAInterval(0.009173462974251, 0.009173462974255),
                                       IAInterval(0.627410004510911, 0.627410004510925),
                                       IAInterval(0.186294997744537, 0.186294997744545)},
                                      {IAInterval(0.009452399933230, 0.009452399933234),
                                       IAInterval(0.108897886088143, 0.108897886088157),
                                       IAInterval(0.445551056955921, 0.445551056955929)},
                                      {IAInterval(0.002161275410664, 0.002161275410668),
                                       IAInterval(0.925378238802224, 0.925378238802238),
                                       IAInterval(0.037310880598881, 0.037310880598888)},
                                      {IAInterval(0.013788050629068, 0.013788050629072),
                                       IAInterval(0.213149304365793, 0.213149304365807),
                                       IAInterval(0.393425347817096, 0.393425347817104)},
                                      {IAInterval(0.007101825303406, 0.007101825303410),
                                       IAInterval(0.047508776918995, 0.047508776919009),
                                       IAInterval(0.476245611540495, 0.476245611540503)}},
                                     {{IAInterval(0.002202897418557, 0.002202897418559),
                                       IAInterval(0.007570780504686, 0.007570780504705),
                                       IAInterval(0.159133707657054, 0.159133707657079),
                                       IAInterval(0.833295511838216, 0.833295511838259)},
                                      {IAInterval(0.005986398578954, 0.005986398578956),
                                       IAInterval(0.046560364907654, 0.046560364907671),
                                       IAInterval(0.198518132228776, 0.198518132228800),
                                       IAInterval(0.754921502863530, 0.754921502863570)},
                                      {IAInterval(0.001129869602125, 0.001129869602127),
                                       IAInterval(0.064090585608423, 0.064090585608442),
                                       IAInterval(0.004854937607609, 0.004854937607636),
                                       IAInterval(0.931054476783923, 0.931054476783967)},
                                      {IAInterval(0.008667225567218, 0.008667225567220),
                                       IAInterval(0.054987479142977, 0.054987479142994),
                                       IAInterval(0.333134817309577, 0.333134817309597),
                                       IAInterval(0.611877703547409, 0.611877703547445)},
                                      {IAInterval(0.004145711527613, 0.004145711527615),
                                       IAInterval(0.099952296288129, 0.099952296288146),
                                       IAInterval(0.038363684775361, 0.038363684775386),
                                       IAInterval(0.861684018936469, 0.861684018936510)},
                                      {IAInterval(0.007722607822098, 0.007722607822100),
                                       IAInterval(0.106227204720260, 0.106227204720276),
                                       IAInterval(0.215607057390083, 0.215607057390104),
                                       IAInterval(0.678165737889620, 0.678165737889657)},
                                      {IAInterval(0.003695681500254, 0.003695681500256),
                                       IAInterval(0.420023758816222, 0.420023758816233),
                                       IAInterval(0.009831548292781, 0.009831548292801),
                                       IAInterval(0.570144692890966, 0.570144692890997)},
                                      {IAInterval(0.011691745731827, 0.011691745731829),
                                       IAInterval(0.317860123835753, 0.317860123835760),
                                       IAInterval(0.139808071991612, 0.139808071991629),
                                       IAInterval(0.542331804172612, 0.542331804172634)},
                                      {IAInterval(0.003578200238457, 0.003578200238459),
                                       IAInterval(0.010737212856001, 0.010737212856019),
                                       IAInterval(0.280581411423654, 0.280581411423676),
                                       IAInterval(0.708681375720305, 0.708681375720345)}});

  default:
    Exit(std::format("IAQuadrature exact up to degree {} not implemented for triangles!",
                     exactUpTo));
  }
}

#endif


#endif // QUADRATURETRIANGLEDATA_HPP
